require 'restclient'
module Lighthouse
  module Client
    class << self
      DATA_API_PATH = "/api/v1/data"

      def config=(config)
        @config = config
        @host = config["host"].to_s.blank? ? config[:host].to_s : config["host"].to_s
        @port = config["port"].to_s.blank? ? config[:port].to_s : config["port"].to_s
        @access_token = config["access_token"].to_s.blank? ? config[:access_token].to_s : config["access_token"].to_s
        @url = @port.nil? ? @host+DATA_API_PATH : @host+":"+@port+DATA_API_PATH
      end

      def config
        @config
      end

      def uri
        @url
      end

      def send_message(data)
        validate_config
        RestClient.post(@url, data, {auth_token: @access_token})
      end

      def validate_config
        raise "Lighthouse config is not set." if @url == ":" || @url.nil?
        raise "Access token is undefined." unless @access_token
      end
    end
  end
end
